
/*  A Bison parser, made from colgram.y with Bison version GNU Bison version 1.24
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	STRING	258
#define	NUM	259
#define	UNKNOWNSYM	260
#define	STRINGERROR	261
#define	GRAMMAR	262
#define	START	263
#define	RULE	264
#define	TABLE	265
#define	PINS	266
#define	EDGE	267
#define	ENDCOLLAGE	268
#define	DERIVATION	269
#define	TRANSFORMATIONS	270
#define	T_AFFINE	271
#define	T_ROTATIONS	272
#define	T_SCALINGS	273
#define	T_TRANSLATIONS	274
#define	T_SCALETRANSLATIONS	275
#define	FKT	276
#define	MATRIX	277
#define	CONTEXT	278
#define	NEGATIVE	279
#define	ANY	280
#define	OF	281
#define	DELETE	282
#define	SLASH	283
#define	COLON	284
#define	COORDSEP	285
#define	LBRACKET	286
#define	RBRACKET	287
#define	F_OPTION	288
#define	A_OPTION	289
#define	CCP_OPTION	290
#define	R_OPTION	291
#define	D_OPTION	292
#define	DPC_OPTION	293
#define	DEC_OPTION	294
#define	LASTONLY_OPTION	295
#define	SOURCE_OPTION	296
#define	EVAL_OPTION	297
#define	CC_OPTION	298
#define	MP_OPTION	299
#define	V_OPTION	300
#define	KI_OPTION	301
#define	DOT	302
#define	DLINE	303
#define	LINE	304
#define	PLINE	305
#define	PGON	306
#define	FPGON	307
#define	CIRC	308
#define	FCIRC	309
#define	ELL	310
#define	FELL	311
#define	SPHERE	312
#define	CUBE	313
#define	POINTLIGHT	314
#define	CONE	315
#define	CYLINDER	316
#define	PART_ALL	317
#define	PART_SIDES	318
#define	PART_BOTTOM	319
#define	PART_TOP	320
#define	NATIVE	321
#define	UNTIL	322
#define	DO	323
#define	BEGIN_ATTRIBUTES	324
#define	END_ATTRIBUTES	325
#define	PROB	326
#define	GLOBAL	327
#define	COLOR	328
#define	RGB	329
#define	UPTO	330
#define	LASTPIC	331
#define	COLORPROC	332
#define	DOLLAR	333
#define	REPEAT	334
#define	TIMES	335
#define	PLUS	336
#define	MINUS	337
#define	MULTIPLY	338
#define	FKT_SQRT	339
#define	FKT_SIN	340
#define	FKT_COS	341
#define	FKT_TAN	342
#define	FKT_ASIN	343
#define	FKT_ACOS	344
#define	FKT_ATAN	345
#define	FKT_SINH	346
#define	FKT_COSH	347
#define	FKT_TANH	348
#define	FKT_LOG	349
#define	FKT_LOG10	350
#define	FKT_EXP	351
#define	FKT_ROT3D	352
#define	TABLEINFO	353
#define	SEQUENTIAL	354
#define	EXHAUSTPROB	355
#define	ONEFROMBASE	356
#define	PTPUSH	357
#define	PTPOP	358
#define	TRANSLATE	359
#define	MAP	360
#define	TO	361
#define	LBRACE	362
#define	RBRACE	363
#define	CHAIN	364
#define	NOCHAIN	365
#define	BBOX_OPTION	366
#define	BBOX_OPERATION	367

#line 1 "colgram.y"

//
// colgram.y  --  CollageVR
//
// YACC parser for CollageSystem/1 Grammar
//
// Author            : N. Schwabe
// Date of creation  : 3/94
// Last modification : 18 Dec 96 
//
// University of Bremen, Germany
//

#include <limits.h>
#include <stdlib.h>
#include <string.h>
#include <stream.h>
#include "collage.h"
#include "psout.h"
#include "vrout.h"
#include "envi.h"
#include "trans.h"
#include "mathutil.h"
#include "yytypes.h"

static unsigned int curInd;       // Current index into the following arrays (0..2)
static Collage *curCollage[3];    // Currently constructed collage.
								  // [0]=right hand side, [1]=context, [2]=negative context
static PartSet *curPartSet[3]; 
static PinSequence *curPins[3];
static EdgeSet *curEdgeSet[3];
static Boolean curAnyOf[2];       // 'any of' context option. [0]=context, [1]=neg. context
static Boolean curDelContext;
static Part *curPart;
static PointSequence *curPS=0, *curiPS=0;
static Textblock *curTextblock=0;
static TransFinder *curTrans=0, *defaultTrans=0;
static OptionBBox *curOptBBox=0;
static PictSet *curPictSet=0;
static SList<TableElemEntry> *curTableElemEntries=0;
static TableInfo *curTableInfo=0;
static PointSequence *curPTS1=0, *curPTS2=0; // internal point sequences
	// Allocation of these pointer variables is always
	// done within the defining nonterminal. Deallocation,
	// if any, must be done where the result is used. This
	// allows the pointers to be used directly where it
	// is possible, which is much more efficient than always
	// copying the whole structure.  

static char curRuleLabel[256];
static ColorIndex defaultPartColor=1, defaultEdgeColor=1;
static int pseudoPicCnt=1;
static Boolean chainTrans = False; // chain parser point transformations

// Point transformation stack:
#define PT_SIZE 128
static Transformation *ptStack[PT_SIZE]; 
  // (this array is guaranteed by C++ to be completely 0 at startup)
static signed int ptInd = -1; // index into ptStack, -1 <=> stack is empty.


// Point transformation stack utility functions:

static void PtClearStack ()
{
	ptInd = -1;
	memset (ptStack, 0, sizeof(ptStack));
}

static void PtTransform (Point *p)
{
	signed int i;
	for (i=ptInd; i >= 0; i--)
		ptStack[i]->Transform (*p, p);
}

static void PtTransformFigure (Figure *f)
{
	signed int i;
	for (i=ptInd; i >= 0; i--)
		f->Transform (*ptStack[i]);
}



#define YYERROR_VERBOSE 1
#define YYDEBUG 1


#line 92 "colgram.y"
typedef union {
  int       i;
  char      c;
  char      *s; /* read only! */
  NumberRec n;
//  PointRec  p;
  Point     *p;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		425
#define	YYFLAG		-32768
#define	YYNTBASE	113

#define YYTRANSLATE(x) ((unsigned)(x) <= 367 ? yytranslate[x] : 247)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
    46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
    56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
    66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
    76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
    86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
    96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
   106,   107,   108,   109,   110,   111,   112
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     1,     7,     9,    12,    13,    15,    17,    19,    21,
    23,    25,    27,    29,    31,    33,    35,    37,    39,    41,
    43,    45,    47,    49,    51,    53,    56,    59,    62,    65,
    67,    70,    73,    75,    77,    78,    82,    83,    84,    90,
    93,    94,    97,    98,    99,   103,   105,   115,   119,   121,
   123,   127,   129,   131,   132,   135,   136,   144,   145,   148,
   152,   153,   156,   159,   160,   161,   171,   174,   177,   178,
   179,   181,   184,   185,   188,   191,   193,   194,   200,   201,
   202,   208,   209,   212,   213,   215,   216,   217,   221,   225,
   229,   233,   236,   239,   244,   247,   248,   252,   255,   264,
   265,   268,   269,   271,   273,   275,   277,   279,   281,   283,
   285,   287,   289,   291,   293,   295,   298,   302,   306,   311,
   316,   318,   320,   324,   326,   328,   337,   339,   341,   344,
   349,   354,   359,   361,   363,   365,   367,   368,   372,   375,
   377,   378,   381,   382,   386,   388,   391,   392,   395,   396,
   400,   401,   407,   415,   422,   428,   432,   440,   446,   448,
   450,   451,   454,   456,   458,   460,   462,   465,   468,   471,
   472,   477,   478,   481,   482,   486,   488,   489,   496,   502,
   503,   506,   507,   508,   512,   515,   516,   522,   528,   530,
   534,   538,   539,   542,   543,   546,   547,   552,   553,   556,
   559,   562,   565,   566,   567,   572,   573,   574,   578,   580,
   583,   585,   589,   593,   595,   599,   603,   605,   608,   611,
   615,   620,   625,   630,   635,   640,   645,   650,   655,   660,
   665,   670,   675
};

static const short yyrhs[] = {    -1,
   114,   115,   145,   147,   223,     0,   116,     0,   116,   117,
     0,     0,   118,     0,   119,     0,   120,     0,   122,     0,
   123,     0,   124,     0,   125,     0,   126,     0,   132,     0,
   127,     0,   128,     0,   129,     0,   130,     0,   131,     0,
   121,     0,    33,     0,    45,     0,    34,     0,    46,     0,
    35,     0,    38,   244,     0,    39,   244,     0,    37,   244,
     0,    36,   244,     0,    40,     0,    41,     3,     0,    42,
     3,     0,    43,     0,    44,     0,     0,   111,   133,   134,
     0,     0,     0,   135,   137,   112,   136,   138,     0,   137,
   139,     0,     0,   138,   141,     0,     0,     0,     3,   140,
   142,     0,   139,     0,    31,   244,    30,   244,    30,   244,
    30,   244,    32,     0,   142,    30,   143,     0,   143,     0,
   144,     0,   144,    75,   144,     0,   244,     0,    76,     0,
     0,   146,   239,     0,     0,   217,     7,   210,   148,   149,
   151,   154,     0,     0,   150,   239,     0,     8,   152,   169,
     0,     0,   153,   239,     0,   154,   155,     0,     0,     0,
     9,   197,   156,   157,   160,   169,   163,   165,   162,     0,
   211,   158,     0,   159,   210,     0,     0,     0,   159,     0,
    71,   244,     0,     0,   161,   239,     0,    10,   244,     0,
    72,     0,     0,    23,   164,   167,   168,   169,     0,     0,
     0,    24,    23,   166,   167,   169,     0,     0,    25,    26,
     0,     0,    27,     0,     0,     0,   217,   170,   171,     0,
   172,   217,   171,     0,   173,   217,   171,     0,   175,   217,
   171,     0,   217,    13,     0,    11,   198,     0,    12,   197,
   198,   174,     0,    73,   244,     0,     0,   178,   176,   177,
     0,    73,   244,     0,    74,    31,   244,    30,   244,    30,
   244,    32,     0,     0,    77,     3,     0,     0,   179,     0,
   180,     0,   181,     0,   182,     0,   183,     0,   185,     0,
   187,     0,   189,     0,   190,     0,   191,     0,   192,     0,
   196,     0,   194,     0,    47,   202,     0,    49,   202,   202,
     0,    48,   202,   202,     0,    50,   202,   202,   198,     0,
   184,   202,   202,   198,     0,    51,     0,    52,     0,   186,
   202,   202,     0,    53,     0,    54,     0,   188,   202,   202,
   202,   202,   209,    30,   209,     0,    55,     0,    56,     0,
    57,   244,     0,    58,   244,   244,   244,     0,    60,   193,
   244,   244,     0,    61,   193,   244,   244,     0,    62,     0,
    63,     0,    64,     0,    65,     0,     0,    66,   195,   239,
     0,    59,   202,     0,     3,     0,     0,   199,   200,     0,
     0,   202,   201,   200,     0,   217,     0,   217,   208,     0,
     0,   204,   205,     0,     0,   207,   206,   205,     0,     0,
    31,   244,    30,   244,    32,     0,    31,   244,    30,   244,
    30,   244,    32,     0,    97,    31,   207,   207,   244,    32,
     0,    31,   244,    30,   244,    32,     0,   243,    30,   243,
     0,    31,   244,    30,   244,    30,   244,    32,     0,   243,
    30,   243,    30,   243,     0,   244,     0,   211,     0,     0,
    15,   212,     0,   213,     0,   214,     0,   215,     0,   216,
     0,    16,   244,     0,    19,   244,     0,    20,   244,     0,
     0,   107,   218,   108,   217,     0,     0,   219,   218,     0,
     0,   102,   220,   221,     0,   103,     0,     0,   105,    16,
   203,   222,   106,   203,     0,    14,   224,   226,   228,   234,
     0,     0,   225,   239,     0,     0,     0,     8,   227,   239,
     0,   228,   229,     0,     0,    67,   244,    68,   244,   232,
     0,    67,   244,    79,   230,   232,     0,   231,     0,   230,
    30,   231,     0,   244,    80,   244,     0,     0,   233,   239,
     0,     0,   235,   234,     0,     0,    98,   244,   236,   237,
     0,     0,   238,   237,     0,    99,   244,     0,   100,   244,
     0,   101,   244,     0,     0,     0,    69,   240,   241,    70,
     0,     0,     0,     3,   242,   241,     0,     4,     0,    82,
     4,     0,   245,     0,   245,    81,   244,     0,   245,    82,
   244,     0,   246,     0,   246,    83,   245,     0,   246,    28,
   245,     0,     4,     0,    82,   246,     0,    78,     3,     0,
    31,   244,    32,     0,    84,    31,   244,    32,     0,    85,
    31,   244,    32,     0,    86,    31,   244,    32,     0,    87,
    31,   244,    32,     0,    89,    31,   244,    32,     0,    88,
    31,   244,    32,     0,    90,    31,   244,    32,     0,    92,
    31,   244,    32,     0,    91,    31,   244,    32,     0,    93,
    31,   244,    32,     0,    96,    31,   244,    32,     0,    94,
    31,   244,    32,     0,    95,    31,   244,    32,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   147,   177,   183,   186,   187,   190,   191,   192,   193,   194,
   195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
   210,   218,   226,   232,   239,   245,   251,   258,   264,   270,
   276,   299,   322,   328,   337,   348,   353,   358,   365,   370,
   371,   374,   375,   378,   383,   385,   386,   400,   401,   404,
   408,   414,   418,   430,   433,   439,   447,   450,   453,   456,
   463,   466,   470,   471,   474,   479,   495,   497,   499,   504,
   506,   509,   515,   519,   523,   529,   535,   539,   540,   547,
   551,   552,   559,   563,   569,   573,   579,   586,   600,   601,
   602,   603,   606,   619,   631,   635,   642,   650,   654,   658,
   664,   669,   672,   673,   674,   675,   676,   677,   678,   679,
   680,   681,   682,   683,   684,   688,   696,   705,   714,   725,
   736,   738,   742,   751,   753,   757,   771,   773,   777,   785,
   793,   801,   809,   810,   811,   812,   815,   820,   827,   835,
   839,   844,   846,   853,   853,   856,   863,   869,   871,   877,
   877,   880,   895,   905,   914,   930,   946,   956,   968,   971,
   972,   976,   979,   982,   983,   984,   987,   993,   999,  1008,
  1009,  1012,  1013,  1016,  1024,  1024,  1034,  1040,  1061,  1064,
  1067,  1070,  1071,  1074,  1077,  1078,  1081,  1092,  1107,  1108,
  1111,  1123,  1127,  1130,  1131,  1134,  1139,  1144,  1145,  1148,
  1152,  1156,  1163,  1164,  1168,  1171,  1172,  1181,  1184,  1189,
  1196,  1201,  1206,  1213,  1214,  1219,  1247,  1251,  1257,  1279,
  1281,  1285,  1289,  1293,  1297,  1301,  1305,  1311,  1315,  1319,
  1323,  1327,  1331
};

static const char * const yytname[] = {   "$","error","$undefined.","STRING",
"NUM","UNKNOWNSYM","STRINGERROR","GRAMMAR","START","RULE","TABLE","PINS","EDGE",
"ENDCOLLAGE","DERIVATION","TRANSFORMATIONS","T_AFFINE","T_ROTATIONS","T_SCALINGS",
"T_TRANSLATIONS","T_SCALETRANSLATIONS","FKT","MATRIX","CONTEXT","NEGATIVE","ANY",
"OF","DELETE","SLASH","COLON","COORDSEP","LBRACKET","RBRACKET","F_OPTION","A_OPTION",
"CCP_OPTION","R_OPTION","D_OPTION","DPC_OPTION","DEC_OPTION","LASTONLY_OPTION",
"SOURCE_OPTION","EVAL_OPTION","CC_OPTION","MP_OPTION","V_OPTION","KI_OPTION",
"DOT","DLINE","LINE","PLINE","PGON","FPGON","CIRC","FCIRC","ELL","FELL","SPHERE",
"CUBE","POINTLIGHT","CONE","CYLINDER","PART_ALL","PART_SIDES","PART_BOTTOM",
"PART_TOP","NATIVE","UNTIL","DO","BEGIN_ATTRIBUTES","END_ATTRIBUTES","PROB",
"GLOBAL","COLOR","RGB","UPTO","LASTPIC","COLORPROC","DOLLAR","REPEAT","TIMES",
"PLUS","MINUS","MULTIPLY","FKT_SQRT","FKT_SIN","FKT_COS","FKT_TAN","FKT_ASIN",
"FKT_ACOS","FKT_ATAN","FKT_SINH","FKT_COSH","FKT_TANH","FKT_LOG","FKT_LOG10",
"FKT_EXP","FKT_ROT3D","TABLEINFO","SEQUENTIAL","EXHAUSTPROB","ONEFROMBASE","PTPUSH",
"PTPOP","TRANSLATE","MAP","TO","LBRACE","RBRACE","CHAIN","NOCHAIN","BBOX_OPTION",
"BBOX_OPERATION","Description","@1","Optionspart","Options","Option","OptionF",
"OptionV","OptionA","OptionKI","OptionCCP","OptionDPC","OptionDEC","OptionD",
"OptionR","OptionLO","OptionSource","OptionEval","OptionCC","OptionMP","OptionBBox",
"@2","DoOptionBBox","@3","@4","SelectedPics","OperandPics","PictListItem","@5",
"XPictListItem","XNumberList","XNumListItem","XNumber","TbGlobal","@6","Grammarpart",
"@7","TbGrammar","@8","StartCollage","TbStart","@9","Rules","Rule","@10","RuleOptions",
"OptRuleProb","RuleProb","TbRule","@11","Tablenumber","Context","@12","NContext",
"@13","OptAnyOf","OptDelContext","Collage","@14","CollageContent","Pins","OneEdge",
"OptEdgeColor","OnePart","OptPartColor","OptColorProc","Part","Dot","Line","DashLine",
"Polyline","Polygon","PolygonKind","Circle","CircleKind","Ellipse","EllipseKind",
"Sphere","Cube","Cone","Cylinder","ObjectParts","Native","@15","PointLight",
"Label","Points","@16","DoPoints","@17","Point","iPoints","@18","DoiPoints",
"@19","internalPoint","transPoint","Angle","OptTransforms","Transformations",
"Transformation","GeneralTrans","AffineTrans","Translations","ScaleTranslations",
"PtOperations","SomePtOperations","PtOperation","@20","NewPointTrans","@21",
"Derivationpart","TbDerivation","@22","TbDerivStart","@23","DerivEntries","DerivEntry",
"TableElemEntries","TabElemEntry","TbTableEntry","@24","TableInfos","TableInfo",
"@25","TableInfoEntries","TableInfoEntry","Textblock","@26","Strings","@27",
"OldNum","Num","Product","Term",""
};
#endif

static const short yyr1[] = {     0,
   114,   113,   115,   116,   116,   117,   117,   117,   117,   117,
   117,   117,   117,   117,   117,   117,   117,   117,   117,   117,
   118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
   128,   129,   130,   131,   133,   132,   135,   136,   134,   137,
   137,   138,   138,   140,   139,   141,   141,   142,   142,   143,
   143,   144,   144,   146,   145,   148,   147,   150,   149,   151,
   153,   152,   154,   154,   156,   155,   157,   157,   157,   158,
   158,   159,   161,   160,   162,   162,   164,   163,   163,   166,
   165,   165,   167,   167,   168,   168,   170,   169,   171,   171,
   171,   171,   172,   173,   174,   174,   175,   176,   176,   176,
   177,   177,   178,   178,   178,   178,   178,   178,   178,   178,
   178,   178,   178,   178,   178,   179,   180,   181,   182,   183,
   184,   184,   185,   186,   186,   187,   188,   188,   189,   190,
   191,   192,   193,   193,   193,   193,   195,   194,   196,   197,
   199,   198,   201,   200,   200,   202,   204,   203,   206,   205,
   205,   207,   207,   207,   208,   208,   208,   208,   209,   210,
   210,   211,   212,   213,   213,   213,   214,   215,   216,   217,
   217,   218,   218,   220,   219,   219,   222,   221,   223,   225,
   224,   226,   227,   226,   228,   228,   229,   229,   230,   230,
   231,   233,   232,   234,   234,   236,   235,   237,   237,   238,
   238,   238,   239,   240,   239,   241,   242,   241,   243,   243,
   244,   244,   244,   245,   245,   245,   246,   246,   246,   246,
   246,   246,   246,   246,   246,   246,   246,   246,   246,   246,
   246,   246,   246
};

static const short yyr2[] = {     0,
     0,     5,     1,     2,     0,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     2,     2,     2,     2,     1,
     2,     2,     1,     1,     0,     3,     0,     0,     5,     2,
     0,     2,     0,     0,     3,     1,     9,     3,     1,     1,
     3,     1,     1,     0,     2,     0,     7,     0,     2,     3,
     0,     2,     2,     0,     0,     9,     2,     2,     0,     0,
     1,     2,     0,     2,     2,     1,     0,     5,     0,     0,
     5,     0,     2,     0,     1,     0,     0,     3,     3,     3,
     3,     2,     2,     4,     2,     0,     3,     2,     8,     0,
     2,     0,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     2,     3,     3,     4,     4,
     1,     1,     3,     1,     1,     8,     1,     1,     2,     4,
     4,     4,     1,     1,     1,     1,     0,     3,     2,     1,
     0,     2,     0,     3,     1,     2,     0,     2,     0,     3,
     0,     5,     7,     6,     5,     3,     7,     5,     1,     1,
     0,     2,     1,     1,     1,     1,     2,     2,     2,     0,
     4,     0,     2,     0,     3,     1,     0,     6,     5,     0,
     2,     0,     0,     3,     2,     0,     5,     5,     1,     3,
     3,     0,     2,     0,     2,     0,     4,     0,     2,     2,
     2,     2,     0,     0,     4,     0,     0,     3,     1,     2,
     1,     3,     3,     1,     3,     3,     1,     2,     2,     3,
     4,     4,     4,     4,     4,     4,     4,     4,     4,     4,
     4,     4,     4
};

static const short yydefact[] = {     1,
     5,    54,     3,   170,   203,    21,    23,    25,     0,     0,
     0,     0,    30,     0,     0,    33,    34,    22,    24,    35,
     4,     6,     7,     8,    20,     9,    10,    11,    12,    13,
    15,    16,    17,    18,    19,    14,   172,     0,     0,   204,
    55,   217,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    29,   211,
   214,    28,    26,    27,    31,    32,    37,   174,   176,     0,
   172,   180,     2,   161,   206,     0,   219,   218,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    36,    41,     0,   170,   173,
   182,   203,     0,    56,   160,   207,     0,   220,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   212,   213,   216,   215,     0,     0,   175,   171,   183,
   186,   181,     0,     0,     0,   162,   163,   164,   165,   166,
    58,   206,   205,   221,   222,   223,   224,   226,   225,   227,
   229,   228,   230,   232,   233,   231,    44,    38,    40,   147,
   203,   194,   167,   168,   169,     0,   203,   208,     0,    43,
   177,   151,   184,     0,     0,   185,   179,   194,    61,    64,
    59,    53,    45,    49,    50,    52,    39,     0,     0,     0,
   148,   149,     0,   196,   195,   170,   203,    57,     0,     0,
     0,    46,    42,   147,     0,     0,   151,     0,     0,   198,
    60,    87,    62,     0,    63,    48,    51,     0,   178,     0,
     0,   150,   192,   192,   189,     0,     0,     0,     0,   197,
   198,   170,   140,    65,     0,     0,     0,   187,   203,     0,
   188,     0,   200,   201,   202,   199,   141,     0,   170,   170,
   170,   170,   121,   122,   124,   125,   127,   128,     0,     0,
   170,     0,     0,   137,    88,   170,   170,   170,   100,   103,
   104,   105,   106,   107,   170,   108,   170,   109,   170,   110,
   111,   112,   113,   115,   114,     0,    69,     0,     0,   152,
     0,   193,   190,   191,    93,   170,   141,   116,     0,   170,
   170,   170,   129,     0,   139,   133,   134,   135,   136,     0,
     0,   203,   170,   170,   170,     0,     0,   102,   170,   170,
   170,    92,     0,    73,   161,    70,     0,     0,   154,   142,
   143,   145,    96,   209,     0,     0,   146,     0,   118,   117,
   141,     0,     0,     0,   138,    89,    90,    91,    98,     0,
     0,    97,   141,   123,   170,    72,   170,   203,    68,    67,
    71,     0,   153,   170,     0,    94,     0,   210,     0,   119,
   130,   131,   132,     0,   101,   120,   170,    79,    74,     0,
   144,    95,     0,   156,     0,     0,    77,    82,     0,     0,
     0,     0,     0,   159,    84,     0,     0,    47,     0,   155,
   158,     0,     0,     0,    86,    80,     0,    76,    66,     0,
     0,   126,    83,    85,   170,    84,    75,   157,    99,    78,
   170,    81,     0,     0,     0
};

static const short yydefgoto[] = {   423,
     1,     2,     3,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    32,    33,    34,    35,    36,    67,
    96,    97,   170,   126,   187,   159,   169,   203,   183,   184,
   185,     4,     5,    38,   141,   166,   167,   180,   196,   197,
   198,   215,   287,   324,   360,   325,   357,   358,   409,   388,
   395,   397,   416,   405,   415,   211,   232,   265,   266,   267,
   366,   268,   318,   352,   269,   270,   271,   272,   273,   274,
   275,   276,   277,   278,   279,   280,   281,   282,   283,   310,
   284,   312,   285,   234,   295,   296,   330,   364,   331,   171,
   172,   191,   207,   192,   337,   393,   104,   105,   136,   137,
   138,   139,   140,   299,    70,    71,    98,   128,   188,    73,
   101,   102,   131,   161,   162,   176,   224,   225,   238,   239,
   177,   178,   210,   230,   231,    41,    75,   107,   142,   338,
   186,    60,    61
};

static const short yypact[] = {-32768,
-32768,-32768,   202,   -81,   -37,-32768,-32768,-32768,   334,   334,
   334,   334,-32768,    33,    36,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    18,    29,    87,-32768,
-32768,-32768,   334,    95,   334,    88,    99,   100,   101,   102,
   103,   104,   105,   107,   109,   110,   127,   128,-32768,    35,
   -20,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,     5,
    18,-32768,-32768,   145,   158,   130,-32768,-32768,   334,   334,
   334,   334,   334,   334,   334,   334,   334,   334,   334,   334,
   334,   334,   334,   334,   334,-32768,-32768,    58,   -81,-32768,
   156,   -37,    14,-32768,-32768,-32768,    98,-32768,   133,   137,
   138,   139,   140,   141,   142,   143,   144,   146,   147,   148,
   150,-32768,-32768,-32768,-32768,     3,   161,-32768,-32768,-32768,
-32768,-32768,   334,   334,   334,-32768,-32768,-32768,-32768,-32768,
-32768,   158,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
   -37,   -53,-32768,-32768,-32768,   175,   -37,-32768,    61,-32768,
-32768,    -7,-32768,   334,   334,-32768,-32768,    86,-32768,-32768,
-32768,-32768,   155,-32768,   111,-32768,     6,    81,   334,   157,
-32768,-32768,   -48,-32768,-32768,   -81,   -37,   180,    61,    61,
   334,-32768,-32768,-32768,   160,    -7,    -7,   334,   334,   -78,
-32768,-32768,-32768,   188,-32768,-32768,-32768,   164,-32768,   334,
    -7,-32768,-32768,   165,-32768,   116,   334,   334,   334,-32768,
   -78,     0,-32768,-32768,   334,    69,   334,-32768,   -37,   334,
-32768,   334,-32768,-32768,-32768,-32768,-32768,   188,   -81,   -81,
   -81,   -81,-32768,-32768,-32768,-32768,-32768,-32768,   334,   334,
   -81,    46,    46,-32768,-32768,   -81,   -81,   -81,    50,-32768,
-32768,-32768,-32768,-32768,   -81,-32768,   -81,-32768,   -81,-32768,
-32768,-32768,-32768,-32768,-32768,   184,    26,   168,   334,-32768,
   167,-32768,-32768,-32768,-32768,   -81,-32768,-32768,     9,   -81,
   -81,   -81,-32768,   334,-32768,-32768,-32768,-32768,-32768,   334,
   334,   -37,     0,     0,     0,   334,   171,   126,   -81,   -81,
   -81,-32768,   334,-32768,   145,   134,   334,   172,-32768,-32768,
-32768,     9,   135,-32768,   334,   203,-32768,   176,-32768,-32768,
-32768,   334,   334,   334,-32768,-32768,-32768,-32768,-32768,   334,
   206,-32768,-32768,-32768,   -81,-32768,   -81,   -37,-32768,-32768,
-32768,   181,-32768,   -81,   334,-32768,   183,-32768,    11,-32768,
-32768,-32768,-32768,   186,-32768,-32768,   -81,   187,-32768,   334,
-32768,-32768,   334,   192,   334,   334,-32768,   190,   185,    82,
    11,   193,   194,-32768,   200,   195,    17,-32768,   334,-32768,
-32768,   334,   334,   204,   199,-32768,   334,-32768,-32768,   201,
   217,-32768,-32768,-32768,   -81,   200,-32768,-32768,-32768,-32768,
   -81,-32768,   231,   250,-32768
};

static const short yypgoto[] = {-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,    66,-32768,-32768,-32768,    55,
    56,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   -71,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,  -159,-32768,  -319,-32768,  -210,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    -5,
-32768,-32768,-32768,    12,  -235,-32768,  -105,-32768,  -233,    62,
-32768,    60,-32768,  -196,-32768,  -138,   -57,   -18,-32768,-32768,
-32768,-32768,-32768,    -4,   205,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    30,    47,-32768,
    94,-32768,-32768,    42,-32768,   -97,-32768,   132,-32768,  -362,
    -8,    34,   230
};


#define	YYLAST		430


static const short yytable[] = {    39,
    59,    62,    63,    64,   132,   157,   384,    94,   157,   221,
   247,   248,   334,   174,   334,   298,   300,   301,   302,   208,
   227,   228,   229,   189,   237,    37,   407,   305,   401,   133,
   209,    40,   134,   135,    76,    65,   201,   378,    66,   335,
   103,   319,    72,   320,   175,   321,   249,   250,   251,   252,
   253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
   263,   333,    95,   173,    42,   264,   339,   340,   341,   181,
   109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
   119,   120,   121,   122,   123,   353,   354,   355,   408,   190,
   336,    43,   336,    74,   129,   420,   323,    77,   289,   213,
   290,   422,   346,   347,   348,   370,    37,   306,   307,   308,
   309,   399,    99,   400,   158,    92,    93,   376,    79,    68,
    69,   377,   316,   317,   163,   164,   165,   124,   125,    80,
    81,    82,    83,    84,    85,    86,   182,    87,    44,    88,
    89,   292,    45,   386,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    90,    91,   103,
   106,   108,   127,   130,   144,   193,   194,   143,   145,   146,
   147,   148,   149,   150,   151,   152,   160,   153,   154,   155,
   205,   156,   179,   175,   199,   200,   204,   206,   214,   220,
   233,   212,   218,   235,   240,   242,   322,   327,   329,   223,
   226,   350,   351,   363,   323,   369,   368,   365,   375,   387,
   380,   236,   383,   396,   345,   385,   398,   406,   243,   244,
   245,   391,   402,   403,   404,   414,   288,   286,   291,   413,
   424,   226,   418,   294,     6,     7,     8,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,   419,   425,
   303,   304,   202,   216,   361,   217,   421,   311,   381,   297,
   379,   313,   314,   315,   412,   219,   222,   359,   326,   293,
   241,   195,   246,   168,    78,   100,     0,     0,     0,     0,
   328,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   332,     0,     0,     0,   342,     0,     0,     0,     0,
     0,   343,   344,     0,     0,     0,     0,   349,   286,   286,
   286,     0,    20,     0,   356,     0,     0,     0,   362,     0,
     0,     0,     0,     0,     0,     0,   367,     0,     0,     0,
     0,     0,     0,   371,   372,   373,     0,    42,     0,     0,
     0,   374,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   212,     0,     0,     0,   382,     0,     0,   332,
     0,     0,     0,     0,    43,     0,     0,     0,     0,     0,
     0,   389,     0,     0,   390,     0,   392,   394,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   410,     0,     0,   411,   394,     0,     0,     0,   417,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   212,    44,     0,     0,     0,    45,   212,    46,    47,    48,
    49,    50,    51,    52,    53,    54,    55,    56,    57,    58
};

static const short yycheck[] = {     4,
     9,    10,    11,    12,   102,     3,   369,    28,     3,   206,
    11,    12,     4,    67,     4,   249,   250,   251,   252,    68,
    99,   100,   101,    31,   221,   107,    10,   261,   391,    16,
    79,    69,    19,    20,    43,     3,    31,   357,     3,    31,
    15,   275,    14,   277,    98,   279,    47,    48,    49,    50,
    51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
    61,   297,    83,   161,     4,    66,   300,   301,   302,   167,
    79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
    89,    90,    91,    92,    93,   319,   320,   321,    72,    97,
    82,    31,    82,     7,    99,   415,    71,     3,    30,   197,
    32,   421,   313,   314,   315,   341,   107,    62,    63,    64,
    65,    30,   108,    32,   112,    81,    82,   353,    31,   102,
   103,   355,    73,    74,   133,   134,   135,    94,    95,    31,
    31,    31,    31,    31,    31,    31,    76,    31,    78,    31,
    31,   239,    82,   377,    84,    85,    86,    87,    88,    89,
    90,    91,    92,    93,    94,    95,    96,    31,    31,    15,
     3,    32,   105,     8,    32,   174,   175,    70,    32,    32,
    32,    32,    32,    32,    32,    32,    16,    32,    32,    32,
   189,    32,     8,    98,    30,    75,   106,    31,     9,    30,
     3,   196,   201,    30,    30,    80,    13,    30,    32,   208,
   209,    31,    77,    32,    71,    30,     4,    73,     3,    23,
    30,   220,    30,    24,   312,    30,    32,    23,   227,   228,
   229,    30,    30,    30,    25,    27,   235,   232,   237,    26,
     0,   240,    32,   242,    33,    34,    35,    36,    37,    38,
    39,    40,    41,    42,    43,    44,    45,    46,    32,     0,
   259,   260,   187,   199,   326,   200,   416,   263,   364,   248,
   358,   266,   267,   268,   403,   204,   207,   325,   287,   240,
   224,   178,   231,   142,    45,    71,    -1,    -1,    -1,    -1,
   289,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,   296,    -1,    -1,    -1,   304,    -1,    -1,    -1,    -1,
    -1,   310,   311,    -1,    -1,    -1,    -1,   316,   313,   314,
   315,    -1,   111,    -1,   323,    -1,    -1,    -1,   327,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,   335,    -1,    -1,    -1,
    -1,    -1,    -1,   342,   343,   344,    -1,     4,    -1,    -1,
    -1,   350,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,   357,    -1,    -1,    -1,   365,    -1,    -1,   364,
    -1,    -1,    -1,    -1,    31,    -1,    -1,    -1,    -1,    -1,
    -1,   380,    -1,    -1,   383,    -1,   385,   386,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   399,    -1,    -1,   402,   403,    -1,    -1,    -1,   407,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
   415,    78,    -1,    -1,    -1,    82,   421,    84,    85,    86,
    87,    88,    89,    90,    91,    92,    93,    94,    95,    96
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(FROM,TO,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 192 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#else
#define YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#endif

int
yyparse(YYPARSE_PARAM)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 148 "colgram.y"
{
			yylineno = 1;
			curInd = 0;
			curCollage[0] = 0;
			curCollage[1] = 0;
			curCollage[2] = 0;
			curPartSet[0] = 0;
			curPartSet[1] = 0;
			curPartSet[2] = 0;
			curPins[0] = 0;
			curPins[1] = 0;
			curPins[2] = 0;
			curEdgeSet[0] = 0;	
			curEdgeSet[1] = 0;	
			curEdgeSet[2] = 0;
			curPart = 0;
			curPS = 0;
			curiPS = 0;
			curTextblock = 0;
			curTrans = 0;
			curOptBBox = 0;
			curPictSet = 0;
			defaultTrans = 0;
			defaultPartColor = 1;
			defaultEdgeColor = 1;
			pseudoPicCnt = 1;
			PtClearStack ();
			chainTrans = False;
		;
    break;}
case 21:
#line 211 "colgram.y"
{
			strcpy (theEnvi->filenamePattern, yytextbuf);
			theEnvi->output = True;
			thePS.SetPattern (theEnvi->filenamePattern);
		;
    break;}
case 22:
#line 219 "colgram.y"
{
			strcpy (theEnvi->vrFilenamePattern, yytextbuf);
			theEnvi->vrOutput = True;
			theVR.SetPattern (theEnvi->vrFilenamePattern);
		;
    break;}
case 23:
#line 227 "colgram.y"
{
			theEnvi->annotated = True;
		;
    break;}
case 24:
#line 233 "colgram.y"
{
			theEnvi->kInverse = True;
		;
    break;}
case 25:
#line 240 "colgram.y"
{
			theEnvi->colorStepIncr = True;
		;
    break;}
case 26:
#line 246 "colgram.y"
{
			defaultPartColor = yyvsp[0].n.i;	
		;
    break;}
case 27:
#line 252 "colgram.y"
{
			defaultEdgeColor = yyvsp[0].n.i;	
		;
    break;}
case 28:
#line 259 "colgram.y"
{
			theEnvi->dimensions = yyvsp[0].n.i;
		;
    break;}
case 29:
#line 265 "colgram.y"
{
			theEnvi->randInit = yyvsp[0].n.i;
		;
    break;}
case 30:
#line 271 "colgram.y"
{
			theEnvi->lastOnly = True;
		;
    break;}
case 31:
#line 277 "colgram.y"
{
		#if USETCL
			int result;
			if (! theEnvi->interp)
			{
				cout << "/source -> Creating interpreter" << endl;
				theEnvi->interp = Tcl_CreateInterp ();
				Tcl_Init (theEnvi->interp);
			}
			result = Tcl_EvalFile (theEnvi->interp, yyvsp[0].s);
			if (result != TCL_OK)
			{
				char msg[1024];
				sprintf (msg, "Error in script %s: %s", yyvsp[0].s, theEnvi->interp->result);
				yyerror (msg);
			}
		#else
			cerr << "CollageSystem: Warning: /source option without activated scripting support is ignored." << endl;
		#endif
		;
    break;}
case 32:
#line 300 "colgram.y"
{
		#if USETCL
			int result;
			if (! theEnvi->interp)
			{
				cout << "/eval -> Creating interpreter" << endl;
				theEnvi->interp = Tcl_CreateInterp ();
				Tcl_Init (theEnvi->interp);
			}
			result = Tcl_Eval (theEnvi->interp, yyvsp[0].s);
			if (result != TCL_OK)
			{
				char msg[1024];
				sprintf (msg, "Error in /eval: %s", theEnvi->interp->result);
				yyerror (msg);
			}
		#else
			cerr << "CollageSystem: Warning: /eval option without activated scripting support is ignored." << endl;
		#endif
		;
    break;}
case 33:
#line 323 "colgram.y"
{
			theEnvi->colourContext = True;
		;
    break;}
case 34:
#line 329 "colgram.y"
{
			theEnvi->mergeParts = True;
		;
    break;}
case 35:
#line 338 "colgram.y"
{
			if (! theEnvi->bboxCalc)
			{
				theEnvi->bboxCalc = new BoundingBoxCalculator;
				theEnvi->bboxCalc->SetOptions (theEnvi->bboxList);
			}
			curOptBBox = new OptionBBox;
			curOptBBox->option = BBoxOption (yyvsp[0].i);
		;
    break;}
case 36:
#line 348 "colgram.y"
{
			theEnvi->bboxList.Append (curOptBBox);
		;
    break;}
case 37:
#line 354 "colgram.y"
{
			curPictSet = &curOptBBox->selected;
				// (assign new intervals to this picture set.)
		;
    break;}
case 38:
#line 360 "colgram.y"
{	
			curPictSet = &curOptBBox->operands;
				// (assign new intervals to this picture set.)
		;
    break;}
case 39:
#line 365 "colgram.y"
{
			curOptBBox->operation = (BBoxOperation)yyvsp[-2].i; 
		;
    break;}
case 44:
#line 379 "colgram.y"
{
			curPictSet->NewGroup (yytextbuf[0]);
		;
    break;}
case 47:
#line 387 "colgram.y"
{
			curPictSet->NewGroup ('B');
			curPictSet->NewInterval (pseudoPicCnt, pseudoPicCnt);
			
			BoundingBox bb(2);
			bb.GetAt(0)->min = yyvsp[-7].n.r;
			bb.GetAt(0)->max = yyvsp[-3].n.r;
			bb.GetAt(1)->min = yyvsp[-5].n.r;
			bb.GetAt(1)->max = yyvsp[-1].n.r;
			theEnvi->bboxCalc->SetPicture ('B', pseudoPicCnt++, bb);
		;
    break;}
case 50:
#line 405 "colgram.y"
{
			curPictSet->NewInterval (yyvsp[0].i, yyvsp[0].i);
		;
    break;}
case 51:
#line 409 "colgram.y"
{
			curPictSet->NewInterval (yyvsp[-2].i, yyvsp[0].i);
		;
    break;}
case 52:
#line 415 "colgram.y"
{
			yyval.i = yyvsp[0].n.i;
		;
    break;}
case 53:
#line 419 "colgram.y"
{
			yyval.i = BBLastPic;
		;
    break;}
case 54:
#line 431 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 55:
#line 433 "colgram.y"
{	theEnvi->CG->psbGlobal = curTextblock; 
		;
    break;}
case 56:
#line 440 "colgram.y"
{
			if (curTrans)
				defaultTrans = curTrans;
			else
				// default-default is affine transf.:
				defaultTrans = new AffineFinder (theEnvi->dimensions);
		;
    break;}
case 58:
#line 451 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 59:
#line 453 "colgram.y"
{	theEnvi->CG->psbGrammar = curTextblock; ;
    break;}
case 60:
#line 457 "colgram.y"
{	
			theEnvi->CG->SetStart (curCollage[curInd]); // curInd == 0 due to initialization
			// don't deallocate curCollage -- pointer is stored.	
		;
    break;}
case 61:
#line 464 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 62:
#line 466 "colgram.y"
{	theEnvi->CG->psbStart = curTextblock; ;
    break;}
case 65:
#line 475 "colgram.y"
{
		  strcpy (curRuleLabel, yyvsp[0].s);
		  curInd = 0;
		;
    break;}
case 66:
#line 480 "colgram.y"
{
			if (! curTrans)
				curTrans = defaultTrans->Copy();	
			CollageRule *rule = new CollageRule (curRuleLabel, curCollage[0], 
			                                     curCollage[1], curCollage[2],
			                                     curAnyOf[0], curAnyOf[1],
			                                     curDelContext,
			                                     curTrans, yyvsp[0].n.i, yyvsp[-5].n.r);
			// don't deallocate curCollage[] -- pointers are stored.	
			rule->psbRule = curTextblock;
			theEnvi->CG->InsertRule (rule); 
		;
    break;}
case 67:
#line 496 "colgram.y"
{	yyval.n = yyvsp[0].n; ;
    break;}
case 68:
#line 498 "colgram.y"
{	yyval.n = yyvsp[-1].n; ;
    break;}
case 69:
#line 500 "colgram.y"
{	curTrans = 0;
			yyval.n.r = 1.0; ;
    break;}
case 70:
#line 505 "colgram.y"
{	yyval.n.r = 1.0; ;
    break;}
case 72:
#line 510 "colgram.y"
{
			yyval.n = yyvsp[0].n;
		;
    break;}
case 73:
#line 516 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 75:
#line 524 "colgram.y"
{
			yyval.i = yyvsp[0].n.i;
			if (yyval.i == 0)
				yyerror ("Table numbers from 1..n or 'global' instead of 'table <n>'");
		;
    break;}
case 76:
#line 530 "colgram.y"
{
			yyval.i = 0;
		;
    break;}
case 77:
#line 536 "colgram.y"
{	curInd = 1;
			curCollage[1] = 0;
		;
    break;}
case 79:
#line 541 "colgram.y"
{
			curCollage[1] = 0;
			curAnyOf[0] = False; // but this is ignored anyway
		;
    break;}
case 80:
#line 548 "colgram.y"
{	curInd = 2;
			curCollage[2] = 0;
		;
    break;}
case 82:
#line 553 "colgram.y"
{
			curCollage[2] = 0;
			curAnyOf[1] = False; // but this is ignored anyway
		;
    break;}
case 83:
#line 560 "colgram.y"
{
			curAnyOf[curInd-1] = True;
		;
    break;}
case 84:
#line 564 "colgram.y"
{
			curAnyOf[curInd-1] = False;
		;
    break;}
case 85:
#line 570 "colgram.y"
{
			curDelContext = True;
		;
    break;}
case 86:
#line 574 "colgram.y"
{
			curDelContext = False;
		;
    break;}
case 87:
#line 580 "colgram.y"
{
			curPins[curInd] = 0;
			curPartSet[curInd] = 0;
			curEdgeSet[curInd] = 0;
		;
    break;}
case 88:
#line 586 "colgram.y"
{
			if (! curPins[curInd]) 
				curPins[curInd] = new PinSequence;
			if (! curPartSet[curInd]) 
				curPartSet[curInd] = new PartSet;
			if (! curEdgeSet[curInd])
				curEdgeSet[curInd] = new EdgeSet;
			
			curCollage[curInd] = new Collage (curPins[curInd], curPartSet[curInd],
			                                  curEdgeSet[curInd]);
			// don't deallocate curPins, curPartSet, curEdgeSet.
		;
    break;}
case 93:
#line 607 "colgram.y"
{
			if (curPins[curInd])
				yyerror ("Pin-points defined twice");
			else {
				curPins[curInd] = new PinSequence;
				*curPins[curInd] = *curPS; // elementwise copy
				delete curPS;
			}
		;
    break;}
case 94:
#line 620 "colgram.y"
{
			if (! curEdgeSet[curInd])
				curEdgeSet[curInd] = new EdgeSet;
			Hyperedge *edge = new Hyperedge (yyvsp[-2].s);
			edge->SetColor ((ColorIndex)yyvsp[0].n.i);
			*edge = *curPS; // elementwise copy
			delete curPS; 
			curEdgeSet[curInd]->Include (edge); 
		;
    break;}
case 95:
#line 632 "colgram.y"
{
			yyval.n.i = yyvsp[0].n.i;
		;
    break;}
case 96:
#line 636 "colgram.y"
{
			yyval.n.i = defaultEdgeColor;
		;
    break;}
case 97:
#line 643 "colgram.y"
{
			if (! curPartSet[curInd])
				curPartSet[curInd] = new PartSet;
			curPartSet[curInd]->Include (*curPart);
		;
    break;}
case 98:
#line 651 "colgram.y"
{
			curPart->SetColor (yyvsp[0].n.i);
		;
    break;}
case 99:
#line 655 "colgram.y"
{
			curPart->SetRGB (RGBValue(yyvsp[-5].n.i, yyvsp[-3].n.i, yyvsp[-1].n.i));
		;
    break;}
case 100:
#line 659 "colgram.y"
{
			curPart->SetColor (defaultPartColor);
		;
    break;}
case 101:
#line 665 "colgram.y"
{
			SString<char> procname (yyvsp[0].s);
			curPart->SetColorProc (procname);
		;
    break;}
case 116:
#line 689 "colgram.y"
{
			Dot *dot = new Dot (*yyvsp[0].p);
			delete yyvsp[0].p;
			curPart = dot;
		;
    break;}
case 117:
#line 697 "colgram.y"
{
			Line *line = new Line (*yyvsp[-1].p, *yyvsp[0].p);
			delete yyvsp[-1].p; 
			delete yyvsp[0].p;
			curPart = line;
		;
    break;}
case 118:
#line 706 "colgram.y"
{
			DashLine *dline = new DashLine (*yyvsp[-1].p, *yyvsp[0].p);
			delete yyvsp[-1].p;
			delete yyvsp[0].p;
			curPart = dline;
		;
    break;}
case 119:
#line 715 "colgram.y"
{
			PolyLine *pline = new PolyLine (*curPS);
			pline->Insert (*yyvsp[-1].p);
			pline->Insert (*yyvsp[-2].p);
			delete yyvsp[-2].p;
			delete yyvsp[-1].p;
			curPart = pline;
		;
    break;}
case 120:
#line 726 "colgram.y"
{
			Polygon *pgon = new Polygon (*curPS, (Boolean)yyvsp[-3].i);
			pgon->Insert (*yyvsp[-1].p);
			pgon->Insert (*yyvsp[-2].p);
			delete yyvsp[-2].p;
			delete yyvsp[-1].p;
			curPart = pgon;
		;
    break;}
case 121:
#line 737 "colgram.y"
{	yyval.i = 0; ;
    break;}
case 122:
#line 739 "colgram.y"
{	yyval.i = 1; ;
    break;}
case 123:
#line 743 "colgram.y"
{
			Ellipse *circle = new Ellipse (*yyvsp[-1].p, *yyvsp[0].p, (Boolean)yyvsp[-2].i);
			delete yyvsp[-1].p;
			delete yyvsp[0].p;
			curPart = circle;
		;
    break;}
case 124:
#line 752 "colgram.y"
{	yyval.i = 0; ;
    break;}
case 125:
#line 754 "colgram.y"
{	yyval.i = 1; ;
    break;}
case 126:
#line 758 "colgram.y"
{
			Ellipse *ellipse = new Ellipse (
			  Line (*yyvsp[-6].p, *yyvsp[-5].p),
			  Line (*yyvsp[-4].p, *yyvsp[-3].p),
			  (Boolean)yyvsp[-7].i, yyvsp[-2].n.r, yyvsp[-1].n.r);
			delete yyvsp[-6].p;
			delete yyvsp[-5].p;
			delete yyvsp[-4].p;
			delete yyvsp[-3].p;
			curPart = ellipse;
		;
    break;}
case 127:
#line 772 "colgram.y"
{	yyval.i = 0; ;
    break;}
case 128:
#line 774 "colgram.y"
{	yyval.i = 1; ;
    break;}
case 129:
#line 778 "colgram.y"
{
			Sphere* sphere = new Sphere (yyvsp[0].n.r);
			PtTransformFigure (sphere);
			curPart = sphere;
		;
    break;}
case 130:
#line 786 "colgram.y"
{
			Cube* cube = new Cube (yyvsp[-2].n.r, yyvsp[-1].n.r, yyvsp[0].n.r);
			PtTransformFigure (cube);
			curPart = cube;
		;
    break;}
case 131:
#line 794 "colgram.y"
{
			Cone* cone = new Cone (yyvsp[-1].n.r, yyvsp[0].n.r, (Cone::Parts)yyvsp[-2].n.i);
			PtTransformFigure (cone);
			curPart = cone;
		;
    break;}
case 132:
#line 802 "colgram.y"
{
			Cylinder* cylinder = new Cylinder (yyvsp[-1].n.r, yyvsp[0].n.r, (Cylinder::Parts)yyvsp[-2].n.i);
			PtTransformFigure (cylinder);
			curPart = cylinder;
		;
    break;}
case 133:
#line 809 "colgram.y"
{yyval.i = 0;;
    break;}
case 134:
#line 810 "colgram.y"
{yyval.i = 1;;
    break;}
case 135:
#line 811 "colgram.y"
{yyval.i = 2;;
    break;}
case 136:
#line 812 "colgram.y"
{yyval.i = 3;;
    break;}
case 137:
#line 816 "colgram.y"
{
			curTextblock = NULL;
		;
    break;}
case 138:
#line 820 "colgram.y"
{
			Native* native = new Native (curTextblock);
			PtTransformFigure (native);
			curPart = native;
		;
    break;}
case 139:
#line 828 "colgram.y"
{
			PointLight* light = new PointLight (*yyvsp[0].p);
			delete yyvsp[0].p;
			curPart = light;
		;
    break;}
case 140:
#line 835 "colgram.y"
{yyval.s = yyvsp[0].s;;
    break;}
case 141:
#line 840 "colgram.y"
{
			curPS = new PointSequence;
		;
    break;}
case 143:
#line 847 "colgram.y"
{
			curPS->Append (*yyvsp[0].p);
			delete yyvsp[0].p;
		;
    break;}
case 146:
#line 857 "colgram.y"
{
				yyval.p = yyvsp[0].p;
			;
    break;}
case 147:
#line 864 "colgram.y"
{
			curiPS = new PointSequence; 
		;
    break;}
case 149:
#line 872 "colgram.y"
{
			curiPS->Append (*yyvsp[0].p);
			delete yyvsp[0].p;
		;
    break;}
case 152:
#line 881 "colgram.y"
{
			yyval.p = new Point (2/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-3].n.r);
			yyval.p->Set (1, yyvsp[-1].n.r);
		#if 0
			if (theEnvi->dimensions > 2) 
			{
				cout << "Grammar: 2-D points conversion to " << 
				theEnvi->dimensions << "-D, padding with 0's." << endl;
				for (int d=2; d < theEnvi->dimensions; d++)
					yyval.p->Set (d, 0);
			}
		#endif
		;
    break;}
case 153:
#line 896 "colgram.y"
{
			yyval.p = new Point (3/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-5].n.r);
			yyval.p->Set (1, yyvsp[-3].n.r);
			yyval.p->Set (2, yyvsp[-1].n.r);
			if (theEnvi->dimensions < 3)
				yyerror ("3-D points only allowed in 3-D mode");
		;
    break;}
case 154:
#line 906 "colgram.y"
{
			Point null (3);
			null.Set(0,0); null.Set(1,0); null.Set(2,0);
			yyval.p = new Point (3);
			Rotate3d (yyvsp[-3].p, &null, yyvsp[-2].p, yyvsp[-1].n.r, yyval.p);
		;
    break;}
case 155:
#line 915 "colgram.y"
{
			yyval.p = new Point (2/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-3].n.r);
			yyval.p->Set (1, yyvsp[-1].n.r);
		#if 0	
			if (theEnvi->dimensions > 2) 
			{
				cout << "Grammar: 2-D points conversion to " << 
				theEnvi->dimensions << "-D, padding with 0's." << endl;
				for (int d=2; d < theEnvi->dimensions; d++)
					yyval.p->Set (d, 0);
			}
		#endif
			PtTransform (yyval.p);
		;
    break;}
case 156:
#line 931 "colgram.y"
{
			yyval.p = new Point (2/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-2].n.r);
			yyval.p->Set (1, yyvsp[0].n.r);
		#if 0	
			if (theEnvi->dimensions > 2) 
			{
				cout << "Grammar: 2-D points conversion to " << 
				theEnvi->dimensions << "-D, padding with 0's." << endl;
				for (int d=2; d < theEnvi->dimensions; d++)
					yyval.p->Set (d, 0);
			}
		#endif
			PtTransform (yyval.p);
		;
    break;}
case 157:
#line 947 "colgram.y"
{
			yyval.p = new Point (3/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-5].n.r);
			yyval.p->Set (1, yyvsp[-3].n.r);
			yyval.p->Set (2, yyvsp[-1].n.r);
			if (theEnvi->dimensions < 3)
				yyerror ("3-D points only allowed in 3-D mode");
			PtTransform (yyval.p);
		;
    break;}
case 158:
#line 957 "colgram.y"
{
			yyval.p = new Point (3/*theEnvi->dimensions*/);	
			yyval.p->Set (0, yyvsp[-4].n.r);
			yyval.p->Set (1, yyvsp[-2].n.r);
			yyval.p->Set (2, yyvsp[0].n.r);
			if (theEnvi->dimensions < 3)
				yyerror ("3-D points only allowed in 3-D mode");
			PtTransform (yyval.p);
		;
    break;}
case 161:
#line 973 "colgram.y"
{	curTrans = 0;;
    break;}
case 167:
#line 988 "colgram.y"
{
			curTrans = new AffineFinder (yyvsp[0].n.i);
                ;
    break;}
case 168:
#line 994 "colgram.y"
{
			curTrans = new TranslationFinder (yyvsp[0].n.i);
                ;
    break;}
case 169:
#line 1000 "colgram.y"
{
			curTrans = new ScaleTranslationFinder (yyvsp[0].n.i);
                ;
    break;}
case 174:
#line 1017 "colgram.y"
{
					ptInd++;
					if (ptInd >= PT_SIZE)
						yyerror ("Point transformation stack size exceeded (PT_SIZE in colgram.y).");	
				;
    break;}
case 176:
#line 1025 "colgram.y"
{
					if (ptInd < 0)
						yyerror ("POP on empty point transformation stack.");
					delete ptStack[ptInd];
					ptStack[ptInd] = 0; // just to uncover illegal access.
					ptInd--;
				;
    break;}
case 177:
#line 1035 "colgram.y"
{
				if (curPTS1)
					delete curPTS1;
				curPTS1 = curiPS;
			;
    break;}
case 178:
#line 1041 "colgram.y"
{
				if (curPTS2)
					delete curPTS2;
				curPTS2 = curiPS;			
				Point *ptest = curPTS1->GetAt (0);
				if (! ptest)
					yyerror ("You must provide at least one point in each internal point list.");
				AffineFinder af (ptest->GetDim());
				Transformation *t = af.FindTrans (*curPTS1, *curPTS2);
				if (! t)
					yyerror ("ptrans map affine: transformation not found.");	
				else
				{
					ptStack[ptInd] = t;
				}	
			;
    break;}
case 180:
#line 1065 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 181:
#line 1067 "colgram.y"
{	theEnvi->derivationTable->psbDerivation = curTextblock; ;
    break;}
case 183:
#line 1072 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 184:
#line 1074 "colgram.y"
{ 	theEnvi->derivationTable->psbDerivStart = curTextblock; ;
    break;}
case 187:
#line 1082 "colgram.y"
{
			TableElement *tabElem = new TableElement (yyvsp[-3].n.i, curTextblock);
			TableElemEntry entry (1, yyvsp[-1].n.i);
			tabElem->entries.Append (entry);
			if (! theEnvi->derivationTable->Insert (tabElem))
			{
				delete tabElem;
				yyerror ("Duplicate derivation entry");
			}
		;
    break;}
case 188:
#line 1093 "colgram.y"
{
			TableElement *tabElem = new TableElement (yyvsp[-3].n.i, curTextblock);
			tabElem->entries = *curTableElemEntries;

			if (! theEnvi->derivationTable->Insert (tabElem))
			{
				delete tabElem;
				yyerror ("Duplicate derivation entry");
			}
			delete curTableElemEntries;
			curTableElemEntries = NULL;
		;
    break;}
case 191:
#line 1112 "colgram.y"
{
			if (! curTableElemEntries)
				curTableElemEntries = new SList<TableElemEntry>;
			if (yyvsp[-2].n.i > 0)
			{
				TableElemEntry entry (yyvsp[-2].n.i, yyvsp[0].n.i);
				curTableElemEntries->Append (entry);
			}
		;
    break;}
case 192:
#line 1124 "colgram.y"
{	curTextblock = NULL; ;
    break;}
case 196:
#line 1135 "colgram.y"
{
			curTableInfo = new TableInfo (yyvsp[0].n.i);
		;
    break;}
case 197:
#line 1139 "colgram.y"
{
			theEnvi->tableInfoList.Append (curTableInfo); // pointer stored
		;
    break;}
case 200:
#line 1149 "colgram.y"
{
				curTableInfo->SetSequential ((Boolean)yyvsp[0].n.i);
			;
    break;}
case 201:
#line 1153 "colgram.y"
{
				curTableInfo->SetExhaustProb ((Boolean)yyvsp[0].n.i);
			;
    break;}
case 202:
#line 1157 "colgram.y"
{
				curTableInfo->SetOneFromBase ((Boolean)yyvsp[0].n.i);
			;
    break;}
case 204:
#line 1165 "colgram.y"
{
			curTextblock = new Textblock;
		;
    break;}
case 207:
#line 1173 "colgram.y"
{
			char *str = yyvsp[0].s, *copy;
			copy = (char *)malloc (strlen(str)+1);
			// note: this is currently never deallocated!			
			strcpy (copy, str);
			curTextblock->Append (copy);
		;
    break;}
case 209:
#line 1185 "colgram.y"
{
			yyval.n.i = yyvsp[0].n.i;
			yyval.n.r = yyvsp[0].n.r;
		;
    break;}
case 210:
#line 1190 "colgram.y"
{
			yyval.n.i = -yyvsp[0].n.i;
			yyval.n.r = -yyvsp[0].n.r;
		;
    break;}
case 211:
#line 1197 "colgram.y"
{
			yyval.n.i = yyvsp[0].n.i;
			yyval.n.r = yyvsp[0].n.r;
		;
    break;}
case 212:
#line 1202 "colgram.y"
{
			yyval.n.i = yyvsp[-2].n.i + yyvsp[0].n.i;
			yyval.n.r = yyvsp[-2].n.r + yyvsp[0].n.r;
		;
    break;}
case 213:
#line 1207 "colgram.y"
{
			yyval.n.i = yyvsp[-2].n.i - yyvsp[0].n.i;
			yyval.n.r = yyvsp[-2].n.r - yyvsp[0].n.r;
		;
    break;}
case 215:
#line 1215 "colgram.y"
{
			yyval.n.i = yyvsp[-2].n.i * yyvsp[0].n.i;
			yyval.n.r = yyvsp[-2].n.r * yyvsp[0].n.r;
		;
    break;}
case 216:
#line 1220 "colgram.y"
{
			if (yyvsp[0].n.i != 0) 
				yyval.n.i = yyvsp[-2].n.i / yyvsp[0].n.i;
			else {
				cerr << "CollageSystem warning: integer division by zero, fixing..." << endl;
				if (yyvsp[-2].n.i > 0) 
					yyval.n.i = LONG_MAX;
				else if (yyvsp[-2].n.i < 0)
					yyval.n.i = LONG_MIN;
				else
					yyval.n.i = 0;
			}

			if (yyvsp[0].n.r != 0.0) 
				yyval.n.r = yyvsp[-2].n.r / yyvsp[0].n.r;
			else {
				cerr << "CollageSystem warning: floating point division by zero, fixing..." << endl;
				if (yyvsp[-2].n.r > 0.0) 
					yyval.n.r = DBL_MAX;
				else if (yyvsp[-2].n.r < 0)
					yyval.n.r = DBL_MIN;
				else
					yyval.n.r = 0.0;
			}
		;
    break;}
case 217:
#line 1248 "colgram.y"
{
			yyval.n = yyvsp[0].n;
		;
    break;}
case 218:
#line 1252 "colgram.y"
{	
			yyval.n.i = -yyvsp[0].n.i;
			yyval.n.r = -yyvsp[0].n.r;
		;
    break;}
case 219:
#line 1258 "colgram.y"
{
		#if USETCL
			if (! theEnvi->interp) 
			{
				yyerror ("Attempt to substitute variable without any script /source'd");
			}
			else	
			{
				char *varname = yyvsp[0].s, *content;
				content = Tcl_GetVar (theEnvi->interp, varname, TCL_GLOBAL_ONLY);
				if (! content)
					yyerror ("Variable has not been defined by any script.");
				yyval.n.i = atoi (content);
				yyval.n.r = atof (content);
			}
		#else
			cout << "CollageSystem: WARNING: no scripting support, Substituting 0 for expression $" << yyvsp[0].s << endl;
			yyval.n.i = 0;
			yyval.n.r = 0.0;
		#endif
		;
    break;}
case 220:
#line 1280 "colgram.y"
{yyval.n = yyvsp[-1].n;;
    break;}
case 221:
#line 1282 "colgram.y"
{	//$<n>$.i = (int)sqrt ($<n>3.i);
			yyval.n.r = sqrt (yyvsp[-1].n.r);
		;
    break;}
case 222:
#line 1286 "colgram.y"
{	//$<n>$.i = (int)sin ($<n>3.i);
			yyval.n.r = sin (yyvsp[-1].n.r);
		;
    break;}
case 223:
#line 1290 "colgram.y"
{	//$<n>$.i = (int)cos ($<n>3.i);
			yyval.n.r = cos (yyvsp[-1].n.r);
		;
    break;}
case 224:
#line 1294 "colgram.y"
{	//$<n>$.i = (int)tan ($<n>3.i);
			yyval.n.r = tan (yyvsp[-1].n.r);
		;
    break;}
case 225:
#line 1298 "colgram.y"
{	//$<n>$.i = (int)acos ($<n>3.i);
			yyval.n.r = acos (yyvsp[-1].n.r);
		;
    break;}
case 226:
#line 1302 "colgram.y"
{	//$<n>$.i = (int)asin ($<n>3.i);
			yyval.n.r = asin (yyvsp[-1].n.r);
		;
    break;}
case 227:
#line 1306 "colgram.y"
{	//$<n>$.i = (int)atan ($<n>3.i);
			cerr << "atan(" << yyvsp[-1].n.r << ") = ";
			yyval.n.r = atan (yyvsp[-1].n.r);
			cerr << yyval.n.r << endl;
		;
    break;}
case 228:
#line 1312 "colgram.y"
{	//$<n>$.i = (int)cosh ($<n>3.i);
			yyval.n.r = cosh (yyvsp[-1].n.r);
		;
    break;}
case 229:
#line 1316 "colgram.y"
{	//$<n>$.i = (int)sinh ($<n>3.i);
			yyval.n.r = sinh (yyvsp[-1].n.r);
		;
    break;}
case 230:
#line 1320 "colgram.y"
{	//$<n>$.i = (int)tanh ($<n>3.i);
			yyval.n.r = tanh (yyvsp[-1].n.r);
		;
    break;}
case 231:
#line 1324 "colgram.y"
{	//$<n>$.i = (int)exp ($<n>3.i);
			yyval.n.r = exp (yyvsp[-1].n.r);
		;
    break;}
case 232:
#line 1328 "colgram.y"
{	//$<n>$.i = (int)log ($<n>3.i);
			yyval.n.r = log (yyvsp[-1].n.r);
		;
    break;}
case 233:
#line 1332 "colgram.y"
{	//$<n>$.i = (int)log10 ($<n>3.i);
			yyval.n.r = log10 (yyvsp[-1].n.r);
		;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 487 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1336 "colgram.y"


/* There seems to be no standard version of yyerror, so I
   implement one here: */

void yyerror (char *s)
{
	cout << "Grammar: " << s << " -- near line " << yylineno << endl;
	sprintf (yytextbuf, "%s -- near line %i.", s, yylineno);
	longjmp (csjmpbuf, -1);
}


